package com.virtual.plat.server.publiccloud.rest;

import com.extjs.gxt.ui.client.data.BaseModelData;
import com.google.common.collect.Lists;
import com.virtual.common.AppException;
import com.virtual.common.FuncUtil;
import com.virtual.common.StringManager;
import com.virtual.plat.client.rpc.RpcResult;
import com.virtual.plat.server.ServerUtils;
import com.virtual.plat.server.cluster.ClusterHandler;
import com.virtual.plat.server.controller.entity.CpuAndMemory;
import com.virtual.plat.server.controller.entity.ResourcePoolPo;
import com.virtual.plat.server.controller.entity.RpNetPo;
import com.virtual.plat.server.controller.entity.RpProfilePo;
import com.virtual.plat.server.controller.entity.RpStoragePo;
import com.virtual.plat.server.controller.entity.StoragePo;
import com.virtual.plat.server.entity.Cluster;
import com.virtual.plat.server.entity.Domain;
import com.virtual.plat.server.entity.Host;
import com.virtual.plat.server.entity.Hostpool;
import com.virtual.plat.server.entity.PortProfile;
import com.virtual.plat.server.entity.PublicCloud;
import com.virtual.plat.server.entity.RpStorage;
import com.virtual.plat.server.http.pool.HttpConnectionManager;
import com.virtual.plat.server.organize.OrganizationUtils;
import com.virtual.plat.server.publiccloud.rest.BaseCloud;
import com.virtual.plat.server.publiccloud.rest.Cloud;
import com.virtual.plat.server.rs.client.RsClientUtils;
import com.virtual.plat.server.rs.cluster.entity.RsCluster;
import com.virtual.plat.server.rs.entity.RsAllocation;
import com.virtual.plat.server.rs.entity.RsCommList;
import com.virtual.plat.server.rs.entity.RsKeyValue;
import com.virtual.plat.server.rs.entity.RsRate;
import com.virtual.plat.server.rs.host.entity.RsHost;
import com.virtual.plat.server.rs.hostpool.entity.RsHostPool;
import com.virtual.plat.server.rs.organize.entity.RsNetRes;
import com.virtual.plat.server.rs.organize.entity.RsStorageRes;
import com.virtual.plat.server.rs.storage.entity.RsShareFileSystem;
import com.virtual.plat.server.rs.storage.entity.RsStorageVolume;
import com.virtual.plat.server.rs.vm.entity.RsDomain;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.Header;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

public class CasCloud extends Cloud {

   private HttpConnectionManager a = null;
   private static Log b = LogFactory.getLog(BaseCloud.class);
   public static final String CVM_VMLIST_URL = "/cas/casrs/vm/vmList";
   public static final String CVM_VMTEMP_URL = "/cas/casrs/vmTemplate/vmTemplateList";
   public static final String RESOURCE_OVERVIEW_URL = "/cas/casrs/dashboard/resourceOverview";
   public static final String CVM_HOSTPOOL_URL = "/cas/casrs/hostpool/all";
   public static final String CVM_CLUSTER_URL = "/cas/casrs/cluster/clusters";
   public static final String CVM_HOST_IN_CLUSTER_URL = "/cas/casrs/host/all";
   public static final String CVM_HOST_IN_HOSTPOOL_URL = "/cas/casrs/hostpool/host/";
   public static final String CVM_HOST_URL = "/cas/casrs/host";
   public static final String CVM_NET_PROFILE = "/cas/casrs/profile";
   public static final String HOST_STOREPOOLINFO_URL = "/cas/casrs/storage/info";


   public CasCloud(HttpConnectionManager var1, PublicCloud var2) {
      super(var2);
      this.a = var1;
   }

   private List a(PublicCloud var1, boolean var2) {
      ArrayList var3 = Lists.newArrayList();
      DefaultHttpClient var4 = null;
      HttpGet var5 = null;
      boolean var12 = false;

      try {
         var12 = true;
         var4 = this.a.getConnection(var1.getProtocal(), var1.getConnectUri(), var1.getPort().intValue(), var1.getUserName(), var1.getPassword());
         String var6 = "/cas/casrs/vm/vmList";
         if(var2) {
            var6 = "/cas/casrs/vmTemplate/vmTemplateList";
         }

         var6 = var6 + "?offset=0" + "&limit=2147483647" + "&isSync=true";
         (var5 = new HttpGet(var6)).addHeader("accept", "application/xml");
         HttpResponse var16 = var4.execute(var5);
         if(200 != var16.getStatusLine().getStatusCode() && 204 != var16.getStatusLine().getStatusCode()) {
            if(409 == var16.getStatusLine().getStatusCode()) {
               int var18 = ServerUtils.getErrorCode(var16);
               var6 = ServerUtils.getErrorMessage(var16);
               throw new AppException(var18, var6);
            }

            var12 = false;
         } else {
            String var7;
            if(StringUtils.isNotEmpty(var7 = EntityUtils.toString(var16.getEntity(), "UTF-8"))) {
               RsCommList var19;
               if((var19 = (RsCommList)FuncUtil.convertXmlToObject(var7.trim(), RsCommList.class)) != null) {
                  if(var19.getData() != null) {
                     Iterator var20 = var19.getData().iterator();

                     while(var20.hasNext()) {
                        RsDomain var17 = (RsDomain)var20.next();
                        Domain var8;
                        (var8 = new Domain()).setPublicCloudId(var1.getId());
                        var8.setCloudType(Integer.valueOf(2));
                        var8.setUniqueKey("" + var17.getId());
                        var8.setForeignId(var17.getId());
                        var8.setHostKey("" + var17.getHostId());
                        var8.setClusterKey("" + var17.getClusterId());
                        var8.setHpKey("" + var17.getHostPoolId());
                        var8.setStatus(var17.getVmStatus());
                        var8.setTitle(var17.getTitle() == null?var17.getName():var17.getTitle());
                        var8.setDomainName(var17.getName());
                        var8.setEnable(Integer.valueOf(var2?2:1));
                        var8.setDescription(var17.getDescription());
                        var8.setUuid(var17.getUuid() == null?"":var17.getUuid());
                        var8.setCreateDate(var17.getCreateDate() == null?null:var17.getCreateDate());
                        var8.setCpu(Integer.valueOf(var17.getCpu() == null?0:var17.getCpu().intValue()));
                        var8.setMemory(Long.valueOf(var17.getMemory() == null?0L:var17.getMemory().longValue()));
                        var8.setStorageCapacity(var17.getStorageCapacity());
                        var8.setSystem(var17.getSystem());
                        var8.setOsVersion(var17.getOsDesc());
                        var8.setAntivirusEnable(var17.getAntivirusEnable() == null?0:var17.getAntivirusEnable().intValue());
                        var3.add(var8);
                     }

                     var12 = false;
                  } else {
                     var12 = false;
                  }
               } else {
                  var12 = false;
               }
            } else {
               var12 = false;
            }
         }
      } catch (AppException var13) {
         b.error((Object)null, var13);
         throw var13;
      } catch (Exception var14) {
         b.error((Object)null, var14);
         throw new AppException(11, var14);
      } finally {
         if(var12) {
            if(var5 != null) {
               var5.abort();
            }

            this.a.releaseConnection(var1.getProtocal(), var1.getUri(), var1.getPort().intValue(), var1.getUserName(), var4);
         }
      }

      var5.abort();
      this.a.releaseConnection(var1.getProtocal(), var1.getUri(), var1.getPort().intValue(), var1.getUserName(), var4);
      return var3;
   }

   public List queryVms(byte var1) {
      ArrayList var2 = Lists.newArrayList();
      if((var1 & 10) != 0) {
         var2.addAll(this.a(this.cloud, false));
      }

      if((var1 & 1) != 0) {
         var2.addAll(this.a(this.cloud, true));
      }

      return var2;
   }

   public void testConnection() {
      DefaultHttpClient var1 = null;
      long var2 = System.currentTimeMillis();
      HttpGet var4 = null;
      boolean var14 = false;

      try {
         String var6;
         try {
            var14 = true;
            String var5 = this.cloud.getProtocal() + "://" + this.cloud.getUri() + ":" + this.cloud.getPort();
            this.a.closeConnection(var5, this.cloud.getUserName());
            var6 = null;
            if(this.cloud.getFlag().intValue() == 2) {
               var1 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword(), "VMC RESTful Web Services", "/cas/casrs/operator/test");
               var6 = "/cas/casrs/operator/test";
            } else if(this.cloud.getFlag().intValue() == 4) {
               var1 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword(), "VMC RESTful Web Services", "/cic/casrs/operator/test");
               var6 = "/cic/casrs/operator/test";
            }

            (var4 = new HttpGet(var6)).addHeader("accept", "application/xml");
            HttpResponse var18 = var1.execute(var4);
            if(204 != var18.getStatusLine().getStatusCode()) {
               if(200 != var18.getStatusLine().getStatusCode()) {
                  if(401 == var18.getStatusLine().getStatusCode()) {
                     throw new AppException(11008);
                  }

                  var14 = false;
               } else {
                  var14 = false;
               }
            } else {
               var14 = false;
            }
         } catch (AppException var15) {
            var6 = this.cloud.getProtocal() + "://" + this.cloud.getUri() + ":" + this.cloud.getPort();
            this.a.closeConnection(var6, this.cloud.getUserName());
            b.error((Object)null, var15);
            throw new AppException(11008);
         } catch (Exception var16) {
            b.error((Object)null, var16);
            var6 = this.cloud.getProtocal() + "://" + this.cloud.getUri() + ":" + this.cloud.getPort();
            this.a.closeConnection(var6, this.cloud.getUserName());
            throw new AppException(11008);
         }
      } finally {
         if(var14) {
            long var9 = System.currentTimeMillis() - var2;
            b.debug("Validate Http connection in " + var9 + " ms");
            if(var4 != null) {
               var4.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var1);
         }
      }

      long var19 = System.currentTimeMillis() - var2;
      b.debug("Validate Http connection in " + var19 + " ms");
      var4.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var1);
   }

   public boolean checkTemplate(String var1) {
      return true;
   }

   public RpcResult operatorDomain(String var1, String var2) {
      return null;
   }

   public Map getResourceOverview(String var1) {
      DefaultHttpClient var2 = null;
      var1 = "/cas/casrs/dashboard/resourceOverview?clusterId=" + var1;
      HttpGet var13;
      (var13 = new HttpGet(var1)).addHeader("accept", "application/xml");

      Map var14;
      try {
         HttpResponse var3 = (var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var13);
         if(200 != var3.getStatusLine().getStatusCode() && 204 != var3.getStatusLine().getStatusCode()) {
            int var4 = Integer.valueOf(var3.getFirstHeader("Error-Code").getValue()).intValue();
            String var16 = var3.getFirstHeader("Charset") != null?var3.getFirstHeader("Charset").getValue():null;
            Header var15 = var3.getFirstHeader("Error-Message");
            String var6 = null;

            try {
               var6 = var16 != null?new String(var15.getValue().getBytes("ISO-8859-1"), var16):new String(var15.getValue().getBytes("ISO-8859-1"));
            } catch (UnsupportedEncodingException var10) {
               b.error((Object)null, var10);
            }

            throw new AppException(var4, var6);
         }

         RsCommList var5;
         if((var5 = (RsCommList)FuncUtil.convertXmlToObject(EntityUtils.toString(var3.getEntity(), "UTF-8").trim(), RsCommList.class)) == null) {
            return new HashMap();
         }

         var14 = a((List)var5.getData());
      } catch (Exception var11) {
         b.error((Object)null, var11);
         return new HashMap();
      } finally {
         var13.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      }

      return var14;
   }

   private static Map a(List var0) {
      HashMap var1 = new HashMap();
      Iterator var3 = var0.iterator();

      while(var3.hasNext()) {
         RsKeyValue var2 = (RsKeyValue)var3.next();
         var1.put(var2.getKey(), var2.getValue());
      }

      return var1;
   }

   public String getDomainStatus(String var1) {
      DefaultHttpClient var2 = null;
      HttpGet var3 = null;
      boolean var8 = false;

      String var4;
      label118: {
         label119: {
            label120: {
               try {
                  var8 = true;
                  var4 = "/cas/casrs/vm/" + var1 + "/status";
                  (var3 = new HttpGet(var4)).addHeader("accept", "application/xml");
                  HttpResponse var12 = (var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var3);
                  if(200 == var12.getStatusLine().getStatusCode()) {
                     if(StringUtils.isNotEmpty(var4 = EntityUtils.toString(var12.getEntity(), "UTF-8"))) {
                        var4 = var4;
                        var8 = false;
                        break label118;
                     }

                     var8 = false;
                  } else {
                     var8 = false;
                  }
                  break label119;
               } catch (AppException var9) {
                  b.error("get cvm domain status error, cloudId is " + this.cloud.getId() + ", domainId is " + var1, var9);
                  var8 = false;
               } catch (Exception var10) {
                  b.error("get cvm domain status error, cloudId is " + this.cloud.getId() + ", domainId is " + var1, var10);
                  var8 = false;
                  break label120;
               } finally {
                  if(var8) {
                     if(var3 != null) {
                        var3.abort();
                     }

                     this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
                  }
               }

               if(var3 != null) {
                  var3.abort();
               }

               this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
               return "unknown";
            }

            if(var3 != null) {
               var3.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
            return "unknown";
         }

         var3.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
         return "unknown";
      }

      var3.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      return var4;
   }

   public List queryHostpools() {
      ArrayList var1 = Lists.newArrayList();
      DefaultHttpClient var2 = null;
      HttpGet var3 = null;
      boolean var10 = false;

      try {
         var10 = true;
         var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
         (var3 = new HttpGet("/cas/casrs/hostpool/all")).addHeader("accept", "application/xml");
         HttpResponse var4 = var2.execute(var3);
         if(200 != var4.getStatusLine().getStatusCode() && 204 != var4.getStatusLine().getStatusCode()) {
            if(409 == var4.getStatusLine().getStatusCode()) {
               int var18 = ServerUtils.getErrorCode(var4);
               String var16 = ServerUtils.getErrorMessage(var4);
               throw new AppException(var18, var16);
            }

            var10 = false;
         } else {
            String var5;
            if(StringUtils.isNotEmpty(var5 = EntityUtils.toString(var4.getEntity(), "UTF-8"))) {
               RsCommList var14;
               if((var14 = (RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCommList.class)) != null) {
                  if(var14.getData() != null) {
                     Iterator var15 = var14.getData().iterator();

                     while(var15.hasNext()) {
                        RsHostPool var17 = (RsHostPool)var15.next();
                        Hostpool var6;
                        (var6 = new Hostpool()).setPublicCloudId(this.cloud.getId());
                        var6.setUniqueKey("" + var17.getId());
                        var6.setName(var17.getName());
                        var1.add(var6);
                     }

                     var10 = false;
                  } else {
                     var10 = false;
                  }
               } else {
                  var10 = false;
               }
            } else {
               var10 = false;
            }
         }
      } catch (AppException var11) {
         b.error((Object)null, var11);
         throw var11;
      } catch (Exception var12) {
         b.error((Object)null, var12);
         throw new AppException(11, var12);
      } finally {
         if(var10) {
            if(var3 != null) {
               var3.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
         }
      }

      var3.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      return var1;
   }

   public List queryClusters() {
      ArrayList var1 = Lists.newArrayList();
      DefaultHttpClient var2 = null;
      HttpGet var3 = null;
      boolean var10 = false;

      try {
         var10 = true;
         var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
         (var3 = new HttpGet("/cas/casrs/cluster/clusters")).addHeader("accept", "application/xml");
         HttpResponse var4 = var2.execute(var3);
         if(200 != var4.getStatusLine().getStatusCode() && 204 != var4.getStatusLine().getStatusCode()) {
            if(409 == var4.getStatusLine().getStatusCode()) {
               int var18 = ServerUtils.getErrorCode(var4);
               String var16 = ServerUtils.getErrorMessage(var4);
               throw new AppException(var18, var16);
            }

            var10 = false;
         } else {
            String var5;
            if(StringUtils.isNotEmpty(var5 = EntityUtils.toString(var4.getEntity(), "UTF-8"))) {
               RsCommList var14;
               if((var14 = (RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCommList.class)) != null) {
                  if(var14.getData() != null) {
                     Iterator var15 = var14.getData().iterator();

                     while(var15.hasNext()) {
                        RsCluster var17 = (RsCluster)var15.next();
                        Cluster var6;
                        (var6 = new Cluster()).setPublicCloudId(this.cloud.getId());
                        var6.setUniqueKey("" + var17.getId());
                        var6.setHpKey("" + var17.getHostPoolId());
                        var6.setName(var17.getName());
                        var6.setEnableHA(var17.getEnableHA());
                        var6.setEnableLB(var17.getEnableLB());
                        var6.setEnableIPM(var17.getEnableIPM());
                        var1.add(var6);
                     }

                     var10 = false;
                  } else {
                     var10 = false;
                  }
               } else {
                  var10 = false;
               }
            } else {
               var10 = false;
            }
         }
      } catch (AppException var11) {
         b.error((Object)null, var11);
         throw var11;
      } catch (Exception var12) {
         b.error((Object)null, var12);
         throw new AppException(11, var12);
      } finally {
         if(var10) {
            if(var3 != null) {
               var3.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
         }
      }

      var3.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      return var1;
   }

   public List queryHosts() {
      List var1 = this.queryHostpools();
      ArrayList var2 = Lists.newArrayList();
      Iterator var4 = var1.iterator();

      while(var4.hasNext()) {
         Hostpool var3 = (Hostpool)var4.next();
         var2.addAll(this.a((String)var3.getUniqueKey()));
      }

      return var2;
   }

   private List a(String var1) {
      ArrayList var2 = Lists.newArrayList();
      DefaultHttpClient var3 = null;
      HttpGet var4 = null;
      boolean var10 = false;

      try {
         var10 = true;
         var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
         var1 = String.format("/cas/casrs/hostpool/host/%s?offset=%d&limit=%d", new Object[]{var1, Integer.valueOf(0), Integer.valueOf(200)});
         (var4 = new HttpGet(var1)).addHeader("accept", "application/xml");
         HttpResponse var14 = var3.execute(var4);
         if(200 != var14.getStatusLine().getStatusCode() && 204 != var14.getStatusLine().getStatusCode()) {
            if(409 == var14.getStatusLine().getStatusCode()) {
               int var18 = ServerUtils.getErrorCode(var14);
               var1 = ServerUtils.getErrorMessage(var14);
               throw new AppException(var18, var1);
            }

            var10 = false;
         } else {
            String var5;
            if(StringUtils.isNotEmpty(var5 = EntityUtils.toString(var14.getEntity(), "UTF-8"))) {
               RsCommList var15;
               if((var15 = (RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCommList.class)) != null) {
                  if(var15.getData() != null) {
                     Iterator var16 = var15.getData().iterator();

                     while(var16.hasNext()) {
                        RsHost var17 = (RsHost)var16.next();
                        Host var6;
                        (var6 = new Host()).setPublicCloudId(this.cloud.getId());
                        var6.setUniqueKey("" + var17.getId());
                        var6.setName(var17.getName());
                        var6.setStatus(var17.getStatus());
                        var6.setClusterKey("" + var17.getClusterId());
                        var6.setHpKey("" + var17.getHostPoolId());
                        var6.setIpAddr(var17.getIp());
                        var2.add(var6);
                     }

                     var10 = false;
                  } else {
                     var10 = false;
                  }
               } else {
                  var10 = false;
               }
            } else {
               var10 = false;
            }
         }
      } catch (AppException var11) {
         b.error((Object)null, var11);
         throw var11;
      } catch (Exception var12) {
         b.error((Object)null, var12);
         throw new AppException(11, var12);
      } finally {
         if(var10) {
            if(var4 != null) {
               var4.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
         }
      }

      var4.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      return var2;
   }

   private RsCluster b(String var1) {
      var1 = "/cas/casrs/cluster/" + var1;
      HttpGet var10;
      (var10 = new HttpGet(var1)).addHeader("accept", "application/xml");
      DefaultHttpClient var2 = null;

      try {
         HttpResponse var3 = (var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var10);
         if(200 == var3.getStatusLine().getStatusCode()) {
            String var11;
            if(StringUtils.isNotEmpty(var11 = EntityUtils.toString(var3.getEntity(), "UTF-8"))) {
               RsCluster var12 = (RsCluster)FuncUtil.convertXmlToObject(var11.trim(), RsCluster.class);
               return var12;
            }

            return null;
         }
      } catch (AppException var7) {
         b.error("query resource pool info:", var7);
         if(var7.getErrorCode() == 9101) {
            throw var7;
         }
      } catch (Exception var8) {
         b.error("query cvm cluster info:", var8);
      } finally {
         var10.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      }

      return null;
   }

   public CpuAndMemory queryClusterCpuAndMemory(String var1) {
      String var2 = "/cas/casrs/cluster/summary/" + var1;
      HttpGet var14;
      (var14 = new HttpGet(var2)).addHeader("accept", "application/xml");
      DefaultHttpClient var3 = null;
      CpuAndMemory var4 = null;

      try {
         if(this.b(var1) == null) {
            throw new AppException(17003);
         }

         HttpResponse var12 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var14);
         if(200 != var12.getStatusLine().getStatusCode()) {
            return var4;
         }

         if(StringUtils.isNotEmpty(var1 = EntityUtils.toString(var12.getEntity(), "UTF-8"))) {
            RsCommList var13;
            if((var13 = (RsCommList)FuncUtil.convertXmlToObject(var1.trim(), RsCommList.class)) == null) {
               return null;
            }

            var4 = new CpuAndMemory();
            List var15;
            if((var15 = var13.getData()) != null && !var15.isEmpty()) {
               Iterator var16 = var15.iterator();

               while(var16.hasNext()) {
                  RsKeyValue var5 = (RsKeyValue)var16.next();
                  a((CpuAndMemory)var4, (RsKeyValue)var5);
               }
            }

            return var4;
         }
      } catch (AppException var9) {
         b.error("query resource pool info:", var9);
         throw var9;
      } catch (Exception var10) {
         b.error("query resource pool info:", var10);
         return var4;
      } finally {
         var14.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      }

      return null;
   }

   private static void a(CpuAndMemory var0, RsKeyValue var1) {
      StringManager var2 = StringManager.getManager(ClusterHandler.class);
      if(var1.getKey() != null && var1.getKey().equals(var2.getString("cluster.cpu.total"))) {
         int var3 = FuncUtil.getIntegerValue(var1.getValue()).intValue();
         var0.setCpu(var3);
      }

      if(var1.getKey() != null && var1.getKey().equals(var2.getString("cluster.memory.total"))) {
         String var10;
         if((var10 = var1.getValue()) != null) {
            String var9 = var10.substring(var10.length() - 2, var10.length());
            double var7 = FuncUtil.getDoubleValue(var10.substring(0, var10.length() - 2)).doubleValue();
            if("MB".equals(var9)) {
               var0.setMemory(FuncUtil.getLongValue(Double.valueOf(var7)).longValue());
               return;
            }

            if("GB".equals(var9)) {
               var7 *= 1024.0D;
               var0.setMemory(FuncUtil.getLongValue(Double.valueOf(var7)).longValue());
               return;
            }

            if("TB".equals(var9)) {
               var7 *= 1048576.0D;
               var0.setMemory(FuncUtil.getLongValue(Double.valueOf(var7)).longValue());
               return;
            }
         }

         var0.setMemory(0L);
      }

   }

   public List queryAllCloudClusterByHostpoolId(Long var1) {
      ArrayList var14 = Lists.newArrayList();
      DefaultHttpClient var2 = null;
      HttpGet var3 = null;
      boolean var10 = false;

      label148: {
         label149: {
            try {
               var10 = true;
               var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
               String var4 = "/cas/casrs/cluster/clusters";
               (var3 = new HttpGet(var4)).addHeader("accept", "application/xml");
               HttpResponse var15 = var2.execute(var3);
               if(200 != var15.getStatusLine().getStatusCode() && 204 != var15.getStatusLine().getStatusCode()) {
                  if(409 == var15.getStatusLine().getStatusCode()) {
                     int var19 = ServerUtils.getErrorCode(var15);
                     var4 = ServerUtils.getErrorMessage(var15);
                     throw new AppException(var19, var4);
                  }

                  var10 = false;
               } else {
                  String var5;
                  if(StringUtils.isNotEmpty(var5 = EntityUtils.toString(var15.getEntity(), "UTF-8"))) {
                     RsCommList var16;
                     if((var16 = (RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCommList.class)) != null) {
                        if(var16.getData() != null) {
                           Iterator var17 = var16.getData().iterator();

                           while(var17.hasNext()) {
                              RsCluster var18 = (RsCluster)var17.next();
                              Cluster var6;
                              (var6 = new Cluster()).setHostPoolId(var18.getHostPoolId());
                              var6.setPublicCloudId(this.cloud.getId());
                              var6.setName(var18.getName());
                              var6.setEnableHA(var18.getEnableHA());
                              var6.setEnableLB(var18.getEnableLB());
                              var6.setEnableIPM(var18.getEnableIPM());
                              var14.add(var6);
                           }

                           var10 = false;
                        } else {
                           var10 = false;
                        }
                     } else {
                        var10 = false;
                     }
                  } else {
                     var10 = false;
                  }
               }
               break label148;
            } catch (AppException var11) {
               b.error(var11);
               var10 = false;
            } catch (Exception var12) {
               b.error(var12);
               var10 = false;
               break label149;
            } finally {
               if(var10) {
                  if(var3 != null) {
                     var3.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
               }
            }

            if(var3 != null) {
               var3.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
            return var14;
         }

         if(var3 != null) {
            var3.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
         return var14;
      }

      var3.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      return var14;
   }

   public List queryHostsByCondition(Long var1, Long var2) {
      ArrayList var3 = Lists.newArrayList();
      DefaultHttpClient var4 = null;
      HttpGet var5 = null;
      boolean var10 = false;

      label158: {
         label159: {
            try {
               var10 = true;
               var4 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
               String var6 = "/cas/casrs/host/all";
               if(var1 == null) {
                  var6 = "/cas/casrs/hostpool/host/" + var2 + "/";
               }

               (var5 = new HttpGet(var6)).addHeader("accept", "application/xml");
               HttpResponse var14 = var4.execute(var5);
               if(200 != var14.getStatusLine().getStatusCode() && 204 != var14.getStatusLine().getStatusCode()) {
                  if(409 == var14.getStatusLine().getStatusCode()) {
                     int var20 = ServerUtils.getErrorCode(var14);
                     String var18 = ServerUtils.getErrorMessage(var14);
                     throw new AppException(var20, var18);
                  }

                  var10 = false;
               } else {
                  String var17;
                  if(StringUtils.isNotEmpty(var17 = EntityUtils.toString(var14.getEntity(), "UTF-8"))) {
                     RsCommList var15;
                     if((var15 = (RsCommList)FuncUtil.convertXmlToObject(var17.trim(), RsCommList.class)) != null) {
                        if(var15.getData() != null) {
                           Iterator var16 = var15.getData().iterator();

                           while(var16.hasNext()) {
                              RsHost var19 = (RsHost)var16.next();
                              Host var21;
                              (var21 = new Host()).setName(var19.getName());
                              var21.setUser(var19.getUser());
                              var21.setPw(var19.getPwd());
                              var21.setIpAddr(var19.getIp());
                              var21.setPublicCloudId(this.cloud.getId());
                              var3.add(var21);
                           }

                           var10 = false;
                        } else {
                           var10 = false;
                        }
                     } else {
                        var10 = false;
                     }
                  } else {
                     var10 = false;
                  }
               }
               break label158;
            } catch (AppException var11) {
               b.error(var11);
               var10 = false;
               break label159;
            } catch (Exception var12) {
               b.error(var12);
               var10 = false;
            } finally {
               if(var10) {
                  if(var5 != null) {
                     var5.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
               }
            }

            if(var5 != null) {
               var5.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
            return var3;
         }

         if(var5 != null) {
            var5.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
         return var3;
      }

      var5.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
      return var3;
   }

   public List queryAllHosts() {
      ArrayList var1 = new ArrayList();
      DefaultHttpClient var2 = null;
      HttpGet var3 = null;
      boolean var10 = false;

      label135: {
         label136: {
            try {
               var10 = true;
               var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
               String var4 = "/cas/casrs/host";
               (var3 = new HttpGet(var4)).addHeader("accept", "application/xml");
               HttpResponse var14 = var2.execute(var3);
               if(200 != var14.getStatusLine().getStatusCode() && 204 != var14.getStatusLine().getStatusCode()) {
                  if(409 == var14.getStatusLine().getStatusCode()) {
                     int var16 = ServerUtils.getErrorCode(var14);
                     var4 = ServerUtils.getErrorMessage(var14);
                     throw new AppException(var16, var4);
                  }

                  var10 = false;
               } else {
                  Iterator var15 = ((RsCommList)FuncUtil.convertXmlToObject(EntityUtils.toString(var14.getEntity(), "UTF-8").trim(), RsHost.class)).getData().iterator();

                  while(var15.hasNext()) {
                     RsHost var5 = (RsHost)var15.next();
                     Host var6;
                     (var6 = new Host()).setPublicCloudId(this.cloud.getId());
                     var6.setHostpoolId(var5.getHostPoolId());
                     var6.setClusterId(var5.getClusterId());
                     var6.setName(var5.getName());
                     var6.setIpAddr(var5.getIp());
                     var6.setStatus(var5.getStatus());
                     var6.setStorage(Long.valueOf(var5.getStorage()));
                     var1.add(var6);
                  }

                  var10 = false;
               }
               break label135;
            } catch (AppException var11) {
               b.error(var11);
               var10 = false;
            } catch (Exception var12) {
               b.error(var12);
               var10 = false;
               break label136;
            } finally {
               if(var10) {
                  if(var3 != null) {
                     var3.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
               }
            }

            if(var3 != null) {
               var3.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
            return var1;
         }

         if(var3 != null) {
            var3.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
         return var1;
      }

      var3.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      return var1;
   }

   public List queryAllClusters() {
      ArrayList var1 = new ArrayList();
      DefaultHttpClient var2 = null;
      HttpGet var3 = null;
      boolean var10 = false;

      label152: {
         label153: {
            label154: {
               try {
                  var10 = true;
                  var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword());
                  String var4 = "/cas/casrs/cluster/clusters";
                  (var3 = new HttpGet(var4)).addHeader("accept", "application/xml");
                  HttpResponse var14 = var2.execute(var3);
                  if(200 != var14.getStatusLine().getStatusCode() && 204 != var14.getStatusLine().getStatusCode()) {
                     if(409 == var14.getStatusLine().getStatusCode()) {
                        int var17 = ServerUtils.getErrorCode(var14);
                        var4 = ServerUtils.getErrorMessage(var14);
                        throw new AppException(var17, var4);
                     }

                     var10 = false;
                  } else {
                     String var5;
                     if(!StringUtils.isNotEmpty(var5 = EntityUtils.toString(var14.getEntity(), "UTF-8"))) {
                        var10 = false;
                        break label152;
                     }

                     Iterator var15 = ((RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCluster.class)).getData().iterator();

                     while(var15.hasNext()) {
                        RsCluster var16 = (RsCluster)var15.next();
                        Cluster var6;
                        (var6 = new Cluster()).setPublicCloudId(this.cloud.getId());
                        var6.setHostPoolId(var16.getHostPoolId());
                        var6.setName(var16.getName());
                        var6.setEnableHA(var16.getEnableHA());
                        var6.setEnableLB(var16.getEnableLB());
                        var6.setEnableIPM(var16.getEnableIPM());
                        var1.add(var6);
                     }

                     var10 = false;
                  }
                  break label153;
               } catch (AppException var11) {
                  b.error(var11);
                  var10 = false;
               } catch (Exception var12) {
                  b.error(var12);
                  var10 = false;
                  break label154;
               } finally {
                  if(var10) {
                     if(var3 != null) {
                        var3.abort();
                     }

                     this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
                  }
               }

               if(var3 != null) {
                  var3.abort();
               }

               this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
               return var1;
            }

            if(var3 != null) {
               var3.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
            return var1;
         }

         var3.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
         return var1;
      }

      var3.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      return null;
   }

   public ResourcePoolPo queryClusterSummaryInfo(String var1) {
      var1 = "/cas/casrs/cluster/summary/" + var1;
      HttpGet var18;
      (var18 = new HttpGet(var1)).addHeader("accept", "application/xml");
      DefaultHttpClient var2 = null;

      try {
         ResourcePoolPo var3 = new ResourcePoolPo();
         HttpResponse var4 = (var2 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var18);
         String var24;
         if(200 != var4.getStatusLine().getStatusCode() && 204 != var4.getStatusLine().getStatusCode()) {
            int var23 = Integer.valueOf(var4.getFirstHeader("Error-Code").getValue()).intValue();
            var24 = var4.getFirstHeader("Charset") != null?var4.getFirstHeader("Charset").getValue():null;
            Header var21 = var4.getFirstHeader("Error-Message");
            String var25 = null;

            try {
               var25 = var24 != null?new String(var21.getValue().getBytes("ISO-8859-1"), var24):new String(var21.getValue().getBytes("ISO-8859-1"));
            } catch (UnsupportedEncodingException var14) {
               b.error((Object)null, var14);
            }

            throw new AppException(var23, var25);
         }

         String var5;
         if(!StringUtils.isNotEmpty(var5 = EntityUtils.toString(var4.getEntity(), "UTF-8"))) {
            return null;
         }

         RsCommList var6;
         if((var6 = (RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCommList.class)) != null) {
            List var19;
            if((var19 = var6.getData()) != null && !var19.isEmpty()) {
               StringManager var7 = StringManager.getManager(ClusterHandler.class);
               Iterator var20 = var19.iterator();

               while(var20.hasNext()) {
                  RsKeyValue var22;
                  var24 = (var22 = (RsKeyValue)var20.next()).getKey();
                  String var8 = var22.getValue();
                  if(var24 != null && var8 != null) {
                     CpuAndMemory var9;
                     a((CpuAndMemory)(var9 = new CpuAndMemory()), (RsKeyValue)var22);
                     var3.setCpu(Integer.valueOf(var9.getCpu()));
                     var3.setMemory(Long.valueOf(var9.getMemory()));
                     if("total".equals(var24)) {
                        var3.setVmTotal(FuncUtil.getIntegerValue(var8).intValue());
                     } else if("run".equals(var24)) {
                        var3.setRunningVmTotal(FuncUtil.getIntegerValue(var8).intValue());
                     } else if("shutoff".equals(var24)) {
                        var3.setOffVmTotal(FuncUtil.getIntegerValue(var8).intValue());
                     } else if(var24.equals(var7.getString("cluster.virtual.host.density"))) {
                        var3.setVmPerHost(FuncUtil.getDoubleValue(var8).doubleValue());
                     }
                  }
               }
            }

            return var3;
         }
      } catch (AppException var15) {
         b.error((Object)null, var15);
         throw var15;
      } catch (Exception var16) {
         b.error((Object)null, var16);
         throw new AppException(11);
      } finally {
         var18.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var2);
      }

      return null;
   }

   public List queryStorageInCluster(String var1, Boolean var2) {
      if(var2 == null) {
         var2 = Boolean.valueOf(true);
      }

      DefaultHttpClient var3 = null;
      var1 = "/cas/casrs/storage/fs/query?id=" + var1;
      HttpGet var17;
      (var17 = new HttpGet(var1)).addHeader("accept", "application/xml");
      ArrayList var4 = new ArrayList();

      try {
         HttpResponse var5 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getConnectUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var17);
         if(200 != var5.getStatusLine().getStatusCode() && 204 != var5.getStatusLine().getStatusCode()) {
            int var20 = Integer.valueOf(var5.getFirstHeader("Error-Code").getValue()).intValue();
            String var21 = var5.getFirstHeader("Charset") != null?var5.getFirstHeader("Charset").getValue():null;
            Header var19 = var5.getFirstHeader("Error-Message");
            String var22 = null;

            try {
               var22 = var21 != null?new String(var19.getValue().getBytes("ISO-8859-1"), var21):new String(var19.getValue().getBytes("ISO-8859-1"));
            } catch (UnsupportedEncodingException var13) {
               b.error((Object)null, var13);
            }

            throw new AppException(var20, var22);
         }

         RsCommList var7;
         if((var7 = (RsCommList)FuncUtil.convertXmlToObject(EntityUtils.toString(var5.getEntity(), "UTF-8").trim(), RsCommList.class)) != null && var7.getData() != null) {
            Iterator var8 = var7.getData().iterator();

            while(var8.hasNext()) {
               RsShareFileSystem var18 = (RsShareFileSystem)var8.next();
               if(var2.booleanValue() || var18.getCapacityControl() == null || var18.getCapacityControl().intValue() != 0) {
                  RpStoragePo var6;
                  (var6 = new RpStoragePo()).setId(var18.getId().toString());
                  var6.setName(var18.getName());
                  var6.setPath(var18.getPath());
                  var6.setType(var18.getTypeStr());
                  var6.setStorageCapacity(var18.getMaxSize());
                  var6.setAvalibaleCapacity(FuncUtil.getDoubleValue(var18.getRemainSize()));
                  var4.add(var6);
               }
            }
         }
      } catch (AppException var14) {
         b.error((Object)null, var14);
         throw var14;
      } catch (Exception var15) {
         b.error((Object)null, var15);
         throw new AppException(11);
      } finally {
         var17.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      }

      return var4;
   }

   public List queryProfile() {
      ArrayList var1 = new ArrayList();

      try {
         if(this.cloud != null) {
            String var2 = "/cas/casrs/profile";
            RsCommList var6;
            if((var6 = (RsCommList)RsClientUtils.queryCloudData(this.a, this.cloud, var2, RsCommList.class)) != null && var6.getData() != null && var6.getData().size() > 0) {
               Iterator var7 = var6.getData().iterator();

               while(var7.hasNext()) {
                  PortProfile var3 = (PortProfile)var7.next();
                  RpProfilePo var4;
                  (var4 = new RpProfilePo()).setName(var3.getName());
                  var4.setDescription(var3.getDescription());
                  var4.setType(var3.getType());
                  var4.setVlanType(Integer.valueOf(var3.getVlanType()));
                  var4.setVlanId(var3.getVlanId());
                  var4.setAclName(var3.getAclName());
                  var4.setVnetPriority(var3.getVnetPriority());
                  var4.setInBurstSize(var3.getInBurstSize());
                  var4.setInAvgBandwidth(var3.getInAvgBandwidth());
                  var4.setOutAvgBandwidth(var3.getOutAvgBandwidth());
                  var4.setOutBurstSize(var3.getOutBurstSize());
                  var1.add(var4);
               }
            }
         }

         return var1;
      } catch (AppException var5) {
         b.error((Object)null, var5);
         return var1;
      }
   }

   public List queryStorageRes(PublicCloud var1, String var2) {
      ArrayList var3 = new ArrayList();

      try {
         StoragePo var4;
         List var6;
         if((var6 = OrganizationUtils.queryStorageRes(var1, var2, this.a, 1)) != null && var6.size() > 0) {
            for(Iterator var7 = var6.iterator(); var7.hasNext(); var3.add(var4)) {
               RsStorageRes var8 = (RsStorageRes)var7.next();
               (var4 = new StoragePo()).setId(var8.getId());
               var4.setClusterId(var8.getClusterId());
               var4.setClusterName(var8.getClusterName());
               var4.setPath(var8.getPath());
               var4.setName(var8.getName());
               var4.setTitle(var8.getTitle());
               var4.setFreeSpace(var8.getStorage());
               var4.setType(var8.getType().toString());
               var4.setCapacity(FuncUtil.getDoubleValue(var8.getMaxSize()));
               Integer var9;
               if((var9 = var8.getType()).intValue() == 1) {
                  var4.setType("fs");
               } else if(var9.intValue() == 2) {
                  var4.setType("netfs");
               } else if(var9.intValue() == 3) {
                  var4.setType("scsi");
               }
            }
         }

         return var3;
      } catch (AppException var5) {
         ServerUtils.logAppException(b, var5);
         throw var5;
      }
   }

   public double queryClusterCpuRate(String var1) {
      List var5 = this.a((String)var1, (String)"cpu");
      double var3 = 0.0D;
      Double var6;
      if(!var5.isEmpty() && (var6 = ((RsRate)var5.get(var5.size() - 1)).getRate()) != null) {
         var3 = var6.doubleValue();
      }

      return var3;
   }

   public double queryClusterMemoryRate(String var1) {
      List var5 = this.a((String)var1, (String)"mem");
      double var3 = 0.0D;
      Double var6;
      if(!var5.isEmpty() && (var6 = ((RsRate)var5.get(var5.size() - 1)).getRate()) != null) {
         var3 = var6.doubleValue();
      }

      return var3;
   }

   private List a(String var1, String var2) {
      DefaultHttpClient var3 = null;
      var1 = "/cas/casrs/cluster/avgHostTrend/" + var1 + "/" + var2 + "/30";
      HttpGet var11;
      (var11 = new HttpGet(var1)).addHeader("accept", "application/xml");

      List var14;
      try {
         HttpResponse var12 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var11);
         if(200 != var12.getStatusLine().getStatusCode() && 204 != var12.getStatusLine().getStatusCode()) {
            int var4 = Integer.valueOf(var12.getFirstHeader("Error-Code").getValue()).intValue();
            var2 = ServerUtils.getErrorMessage(var12);
            throw new AppException(var4, var2);
         }

         RsCommList var13;
         if((var13 = (RsCommList)FuncUtil.convertXmlToObject(EntityUtils.toString(var12.getEntity(), "UTF-8"), RsCommList.class)) == null || var13.getData() == null || var13.getData().isEmpty()) {
            ArrayList var15 = new ArrayList();
            return var15;
         }

         var14 = var13.getData();
      } catch (AppException var8) {
         b.error((Object)null, var8);
         throw var8;
      } catch (Exception var9) {
         b.error((Object)null, var9);
         throw new AppException(11);
      } finally {
         var11.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      }

      return var14;
   }

   public List queryNet(String var1) {
      ArrayList var2 = new ArrayList();
      DefaultHttpClient var3 = null;
      var1 = "/cas/casrs/cluster/netRes?clusterIds=" + var1;
      HttpGet var11;
      (var11 = new HttpGet(var1)).addHeader("accept", "application/xml");

      try {
         HttpResponse var4 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var11);
         String var12;
         RsCommList var13;
         if(200 == var4.getStatusLine().getStatusCode() && StringUtils.isNotEmpty(var12 = EntityUtils.toString(var4.getEntity(), "UTF-8")) && (var13 = (RsCommList)FuncUtil.convertXmlToObject(var12.trim(), RsCommList.class)) != null && var13.getData() != null && var13.getData().size() > 0) {
            Iterator var14 = var13.getData().iterator();

            while(var14.hasNext()) {
               RsNetRes var5 = (RsNetRes)var14.next();
               RpNetPo var6;
               (var6 = new RpNetPo()).setName(var5.getName());
               var6.setDesc(var5.getDesc());
               var6.setMode(var5.getMode());
               var2.add(var6);
            }
         }
      } catch (Exception var9) {
         b.error((Object)null, var9);
      } finally {
         var11.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      }

      return var2;
   }

   public List queryVirtHostTop5Rate(String var1, String var2) {
      StringBuilder var3;
      (var3 = new StringBuilder()).append("/cas/casrs/cluster/virtHostTopN/").append(var1).append("/").append(var2);
      HttpGet var11;
      (var11 = new HttpGet(var3.toString())).addHeader("accept", "application/xml");
      DefaultHttpClient var12 = null;

      List var15;
      try {
         HttpResponse var13 = (var12 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var11);
         if(200 != var13.getStatusLine().getStatusCode()) {
            int var16 = Integer.valueOf(var13.getFirstHeader("Error-Code").getValue()).intValue();
            String var17 = ServerUtils.getErrorMessage(var13);
            throw new AppException(var16, var17);
         }

         String var4;
         RsCommList var14;
         if(!StringUtils.isNotEmpty(var4 = EntityUtils.toString(var13.getEntity(), "UTF-8")) || (var14 = (RsCommList)FuncUtil.convertXmlToObject(var4.trim(), RsCommList.class)) == null || var14.getData() == null || var14.getData().size() <= 0) {
            return new ArrayList();
         }

         var15 = var14.getData();
      } catch (AppException var8) {
         b.error((Object)null, var8);
         throw var8;
      } catch (Exception var9) {
         b.error((Object)null, var9);
         throw new AppException(11);
      } finally {
         var11.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var12);
      }

      return var15;
   }

   public List queryComputeResourceTrend(String var1, String var2) {
      return this.a((String)var1, (String)var2);
   }

   public StoragePo queryStorageBaseInfo(String var1) {
      StoragePo var2 = new StoragePo();
      DefaultHttpClient var3 = null;
      var1 = "/cas/casrs/storage/storageAllocation?poolName=" + var1 + "&hostId=0";
      HttpGet var10;
      (var10 = new HttpGet(var1)).addHeader("accept", "application/xml");

      try {
         HttpResponse var4 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var10);
         String var11;
         if(200 == var4.getStatusLine().getStatusCode() && StringUtils.isNotEmpty(var11 = EntityUtils.toString(var4.getEntity(), "UTF-8"))) {
            RsAllocation var12;
            Double var5 = Double.valueOf(FuncUtil.getDoubleValue(Double.valueOf((var12 = (RsAllocation)FuncUtil.convertXmlToObject(var11.trim(), RsAllocation.class)).getPreallocation())).doubleValue() / 1024.0D);
            var2.setCapacity(Double.valueOf(FuncUtil.getDoubleValue(Long.valueOf(var12.getCapacity())).doubleValue() / 1024.0D));
            var2.setFreeSpace(Double.valueOf(FuncUtil.getDoubleValue(Long.valueOf(var12.getAvailable())).doubleValue() / 1024.0D));
            var2.setPreallocation(Double.valueOf(var5.doubleValue() > 0.0D && var5.doubleValue() < 0.01D?0.01D:var5.doubleValue()));
            var2.setName(var12.getPoolName());
            var2.setType(var12.getType());
            var2 = var2;
            return var2;
         }
      } catch (Exception var8) {
         b.error((Object)null, var8);
      } finally {
         var10.abort();
         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      }

      return null;
   }

   public List queryVmStorageInfo(List var1, String var2, String var3) {
      DefaultHttpClient var21 = null;
      HttpGet var4 = null;
      ArrayList var5 = new ArrayList();
      String var6 = "";

      String var7;
      for(Iterator var17 = var1.iterator(); var17.hasNext(); var6 = var6 + var7 + ",") {
         var7 = (String)var17.next();
      }

      boolean var12 = false;

      label191: {
         label192: {
            try {
               var12 = true;
               String var18 = "/cas/casrs/vm/userVmDeviceInfo?domainId=" + var6.substring(0, var6.length() - 1) + "&storageName=" + var2;
               (var4 = new HttpGet(var18)).addHeader("accept", "application/xml");
               HttpResponse var23 = (var21 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var4);
               if(200 != var23.getStatusLine().getStatusCode() && 204 != var23.getStatusLine().getStatusCode()) {
                  var12 = false;
               } else {
                  var18 = null;

                  try {
                     if(var23.getEntity() != null) {
                        var18 = EntityUtils.toString(var23.getEntity(), "UTF-8");
                     }
                  } catch (Exception var13) {
                     b.error((Object)null, var13);
                  }

                  if(var18 != null) {
                     RsCommList var19;
                     if((var19 = (RsCommList)FuncUtil.convertXmlToObject(var18.trim(), RsCommList.class)) != null) {
                        if(var19.getData() != null) {
                           var1 = var19.getData();

                           for(int var20 = 0; var20 < (var1.size() > 5?5:var1.size()); ++var20) {
                              RsStorageVolume var22;
                              (var22 = new RsStorageVolume()).setDomainId(((RsStorageVolume)var1.get(var20)).getDomainId());
                              var22.setSize(Double.valueOf(((RsStorageVolume)var1.get(var20)).getSize().doubleValue() / 1048576.0D));
                              var22.setDomainName(((RsStorageVolume)var1.get(var20)).getDomainName());
                              var5.add(var22);
                           }

                           var12 = false;
                        } else {
                           var12 = false;
                        }
                     } else {
                        var12 = false;
                     }
                  } else {
                     var12 = false;
                  }
               }
               break label191;
            } catch (AppException var14) {
               b.error(var14.getMessage(), var14);
               var12 = false;
            } catch (Exception var15) {
               b.error(var15.getMessage(), var15);
               var12 = false;
               break label192;
            } finally {
               if(var12) {
                  if(var4 != null) {
                     var4.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var21);
               }
            }

            if(var4 != null) {
               var4.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var21);
            return var5;
         }

         if(var4 != null) {
            var4.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var21);
         return var5;
      }

      var4.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var21);
      return var5;
   }

   public List queryStorageHistory(String var1) {
      ArrayList var2 = new ArrayList();
      DefaultHttpClient var3 = null;
      HttpGet var4 = null;
      boolean var14 = false;

      label161: {
         label162: {
            try {
               var14 = true;
               var1 = "/cas/casrs/vm/storageHistory?storageName=" + var1;
               (var4 = new HttpGet(var1)).addHeader("accept", "application/xml");
               HttpResponse var19 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var4);
               if(200 != var19.getStatusLine().getStatusCode() && 204 != var19.getStatusLine().getStatusCode()) {
                  var14 = false;
               } else {
                  String var5 = null;

                  try {
                     if(var19.getEntity() != null) {
                        var5 = EntityUtils.toString(var19.getEntity(), "UTF-8");
                     }
                  } catch (Exception var15) {
                     b.error((Object)null, var15);
                  }

                  if(var5 != null) {
                     SimpleDateFormat var20 = new SimpleDateFormat("hh:mm");
                     RsCommList var21;
                     if((var21 = (RsCommList)FuncUtil.convertXmlToObject(var5.trim(), RsCommList.class)) != null) {
                        if(var21.getData() != null) {
                           for(int var6 = 0; var6 < var21.getData().size(); ++var6) {
                              StoragePo var7;
                              (var7 = new StoragePo()).setRate(((RsAllocation)var21.getData().get(var6)).getRate());
                              Long var8 = Long.valueOf(((RsAllocation)var21.getData().get(var6)).getLastCvkUpdateTime() * 1000L);
                              Calendar var9;
                              (var9 = Calendar.getInstance()).setTimeInMillis(var8.longValue());
                              var7.setName(var20.format(var9.getTime()));
                              var7.setTime(Long.valueOf(((RsAllocation)var21.getData().get(var6)).getLastCvkUpdateTime() * 1000L));
                              var2.add(var7);
                           }

                           var14 = false;
                        } else {
                           var14 = false;
                        }
                     } else {
                        var14 = false;
                     }
                  } else {
                     var14 = false;
                  }
               }
               break label161;
            } catch (AppException var16) {
               b.error("get queryStorageHistory information AppException :" + var16);
               var14 = false;
            } catch (Exception var17) {
               b.error("get queryStorageHistory information Exception :" + var17);
               var14 = false;
               break label162;
            } finally {
               if(var14) {
                  if(var4 != null) {
                     var4.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
               }
            }

            if(var4 != null) {
               var4.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
            return var2;
         }

         if(var4 != null) {
            var4.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
         return var2;
      }

      var4.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      return var2;
   }

   public Map queryOrgStorageInfo(List var1, String var2, String var3) {
      DefaultHttpClient var19 = null;
      HttpGet var4 = null;
      TreeMap var5 = new TreeMap();
      String var6 = "";
      ArrayList var7 = new ArrayList();
      Iterator var8 = var1.iterator();

      while(var8.hasNext()) {
         Domain var9 = (Domain)var8.next();
         if(!var7.contains(var9.getUniqueKey())) {
            var7.add(var9.getUniqueKey());
            var6 = var6 + var9.getUniqueKey() + ",";
         }
      }

      boolean var14 = false;

      label211: {
         label212: {
            try {
               var14 = true;
               String var24 = "/cas/casrs/vm/userVmDeviceInfo?domainId=" + var6.substring(0, var6.length() - 1) + "&storageName=" + var2;
               (var4 = new HttpGet(var24)).addHeader("accept", "application/xml");
               HttpResponse var26 = (var19 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var4);
               if(200 != var26.getStatusLine().getStatusCode() && 204 != var26.getStatusLine().getStatusCode()) {
                  var14 = false;
               } else {
                  var2 = null;

                  try {
                     if(var26.getEntity() != null) {
                        var2 = EntityUtils.toString(var26.getEntity(), "UTF-8");
                     }
                  } catch (Exception var15) {
                     b.error((Object)null, var15);
                  }

                  if(var2 != null) {
                     RsCommList var21;
                     if((var21 = (RsCommList)FuncUtil.convertXmlToObject(var2.trim(), RsCommList.class)) != null) {
                        if(var21.getData() != null) {
                           Iterator var20 = var21.getData().iterator();

                           while(var20.hasNext()) {
                              RsStorageVolume var22 = (RsStorageVolume)var20.next();
                              Iterator var23 = var1.iterator();

                              while(var23.hasNext()) {
                                 Domain var25;
                                 if((var25 = (Domain)var23.next()).getOrgId() != 0L && FuncUtil.getLongValue(var25.getUniqueKey()).equals(var22.getDomainId())) {
                                    if(var5.containsKey(Long.valueOf(var25.getOrgId()))) {
                                       var5.put(Long.valueOf(var25.getOrgId()), Double.valueOf(var22.getSize().doubleValue() / 1048576.0D + ((Double)var5.get(Long.valueOf(var25.getOrgId()))).doubleValue()));
                                    } else {
                                       var5.put(Long.valueOf(var25.getOrgId()), Double.valueOf(var22.getSize().doubleValue() / 1048576.0D));
                                    }
                                 }
                              }
                           }

                           var14 = false;
                        } else {
                           var14 = false;
                        }
                     } else {
                        var14 = false;
                     }
                  } else {
                     var14 = false;
                  }
               }
               break label211;
            } catch (AppException var16) {
               b.error(var16.getMessage(), var16);
               var14 = false;
            } catch (Exception var17) {
               b.error(var17.getMessage(), var17);
               var14 = false;
               break label212;
            } finally {
               if(var14) {
                  if(var4 != null) {
                     var4.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var19);
               }
            }

            if(var4 != null) {
               var4.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var19);
            return var5;
         }

         if(var4 != null) {
            var4.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var19);
         return var5;
      }

      var4.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var19);
      return var5;
   }

   public List queryStorageList(List var1, Cluster var2) {
      ArrayList var3 = new ArrayList();
      BaseModelData var4;
      (var4 = new BaseModelData()).set("clusterId", var2.getUniqueKey());
      List var10 = OrganizationUtils.queryStorageRes(this.cloud, var4, this.a);
      Iterator var9 = var1.iterator();

      while(var9.hasNext()) {
         RpStorage var11 = (RpStorage)var9.next();
         boolean var5 = false;
         StoragePo var6;
         (var6 = new StoragePo()).setId(var11.getId());
         var6.setBackupFlag(var11.getBackupFlag());
         if(var10 != null && var10.size() > 0) {
            Iterator var7 = var10.iterator();

            while(var7.hasNext()) {
               RsStorageRes var8 = (RsStorageRes)var7.next();
               if(var11.getName().equals(var8.getName()) && var11.getPath().equals(var8.getPath()) && var11.getType() == var8.getType().intValue()) {
                  var6.setPath(var8.getPath());
                  var6.setName(var8.getName());
                  var6.setTitle(var8.getTitle());
                  var6.setCapacity(var8.getStorage());
                  var6.setType(a(var8.getType().intValue()));
                  var3.add(var6);
                  var5 = true;
                  break;
               }
            }
         }

         if(!var5) {
            var6.setPath(var11.getPath());
            var6.setName(var11.getName());
            var6.setTitle("");
            var6.setCapacity(Double.valueOf(0.0D));
            var6.setFlag(false);
            var6.setType(a(var11.getType()));
            var3.add(var6);
         }
      }

      return var3;
   }

   private static String a(int var0) {
      String var1 = "";
      if(var0 == 1) {
         var1 = "fs";
      } else if(var0 == 2) {
         var1 = "netfs";
      } else if(var0 == 3) {
         var1 = "scsi";
      }

      return var1;
   }

   public void checkCluster(String var1) {
      if(var1 == null) {
         throw new AppException(17003);
      } else if(this.b(var1) == null) {
         throw new AppException(17003);
      }
   }

   public List queryIORwAndIOPSTrend(String var1, String var2, String var3) {
      DefaultHttpClient var4 = null;
      HttpGet var5 = null;
      ArrayList var6 = new ArrayList();
      boolean var13 = false;

      label164: {
         label165: {
            try {
               var13 = true;
               var1 = "/cas/casrs/storage/iopsAndIoTrend?poolName=" + var1 + "&type=" + var2 + "&clusterId=" + var3;
               (var5 = new HttpGet(var1)).addHeader("accept", "application/xml");
               HttpResponse var18 = (var4 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var5);
               if(200 != var18.getStatusLine().getStatusCode() && 204 != var18.getStatusLine().getStatusCode()) {
                  var13 = false;
               } else {
                  var2 = null;

                  try {
                     if(var18.getEntity() != null) {
                        var2 = EntityUtils.toString(var18.getEntity(), "UTF-8");
                     }
                  } catch (Exception var14) {
                     b.error((Object)null, var14);
                  }

                  if(var2 != null) {
                     RsCommList var19;
                     if((var19 = (RsCommList)FuncUtil.convertXmlToObject(var2.trim(), RsCommList.class)) != null) {
                        if(var19.getData() != null) {
                           ArrayList var20 = new ArrayList();
                           ArrayList var21 = new ArrayList();

                           for(int var7 = 0; var7 < var19.getData().size(); ++var7) {
                              StoragePo var8;
                              (var8 = new StoragePo()).setRate(FuncUtil.getLongValue(((RsRate)var19.getData().get(var7)).getRate()));
                              var8.setTime(((RsRate)var19.getData().get(var7)).getTime());
                              var20.add(var8);
                              (var8 = new StoragePo()).setRate(FuncUtil.getLongValue(((RsRate)var19.getData().get(var7)).getExtraRate()));
                              var8.setTime(((RsRate)var19.getData().get(var7)).getTime());
                              var21.add(var8);
                           }

                           var6.add(var21);
                           var6.add(var20);
                           var13 = false;
                        } else {
                           var13 = false;
                        }
                     } else {
                        var13 = false;
                     }
                  } else {
                     var13 = false;
                  }
               }
               break label164;
            } catch (AppException var15) {
               b.error(var15.getMessage() + var15);
               var13 = false;
            } catch (Exception var16) {
               b.error(var16.getMessage(), var16);
               var13 = false;
               break label165;
            } finally {
               if(var13) {
                  if(var5 != null) {
                     var5.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
               }
            }

            if(var5 != null) {
               var5.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
            return var6;
         }

         if(var5 != null) {
            var5.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
         return var6;
      }

      var5.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var4);
      return var6;
   }

   public List queryOrgVmStorageInfo(List var1, List var2) {
      DefaultHttpClient var3 = null;
      HttpGet var4 = null;
      ArrayList var5 = new ArrayList();
      String var6 = "";
      String var7 = "";

      String var8;
      Iterator var18;
      for(var18 = var1.iterator(); var18.hasNext(); var6 = var6 + var8 + ",") {
         var8 = (String)var18.next();
      }

      for(var18 = var2.iterator(); var18.hasNext(); var7 = var7 + "\'" + var8 + "\',") {
         var8 = (String)var18.next();
      }

      var7 = var7.substring(0, var7.length() - 1);
      var6 = var6.substring(0, var6.length() - 1);
      boolean var13 = false;

      label197: {
         label198: {
            try {
               var13 = true;
               String var19 = "/cas/casrs/vm/userVmStorageCapacity?domainIds=" + var6 + "&storageNames=" + var7;
               (var4 = new HttpGet(var19)).addHeader("accept", "application/xml");
               HttpResponse var23 = (var3 = this.a.getConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), this.cloud.getPassword())).execute(var4);
               if(200 != var23.getStatusLine().getStatusCode() && 204 != var23.getStatusLine().getStatusCode()) {
                  var13 = false;
               } else {
                  var19 = null;

                  try {
                     if(var23.getEntity() != null) {
                        var19 = EntityUtils.toString(var23.getEntity(), "UTF-8");
                     }
                  } catch (Exception var14) {
                     b.error((Object)null, var14);
                  }

                  if(var19 != null) {
                     RsCommList var20;
                     if((var20 = (RsCommList)FuncUtil.convertXmlToObject(var19.trim(), RsCommList.class)) != null) {
                        if(var20.getData() != null) {
                           var1 = var20.getData();

                           for(int var21 = 0; var21 < var1.size(); ++var21) {
                              RsStorageVolume var22;
                              (var22 = new RsStorageVolume()).setDomainId(((RsStorageVolume)var1.get(var21)).getDomainId());
                              var22.setSize(Double.valueOf(((RsStorageVolume)var1.get(var21)).getSize().doubleValue() / 1048576.0D));
                              var22.setDomainName(((RsStorageVolume)var1.get(var21)).getDomainName());
                              var5.add(var22);
                           }

                           var13 = false;
                        } else {
                           var13 = false;
                        }
                     } else {
                        var13 = false;
                     }
                  } else {
                     var13 = false;
                  }
               }
               break label197;
            } catch (AppException var15) {
               b.error(var15.getMessage(), var15);
               var13 = false;
            } catch (Exception var16) {
               b.error(var16.getMessage(), var16);
               var13 = false;
               break label198;
            } finally {
               if(var13) {
                  if(var4 != null) {
                     var4.abort();
                  }

                  this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
               }
            }

            if(var4 != null) {
               var4.abort();
            }

            this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
            return var5;
         }

         if(var4 != null) {
            var4.abort();
         }

         this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
         return var5;
      }

      var4.abort();
      this.a.releaseConnection(this.cloud.getProtocal(), this.cloud.getUri(), this.cloud.getPort().intValue(), this.cloud.getUserName(), var3);
      return var5;
   }

   public List queryStoragePerfTrend(String var1, String var2) {
      return null;
   }

}
